part of tecfy_basic_package;

class ThemeService{

  static final double containerWidth = 1100;
  static final Color mainColor = ConfigService.theme?.mainColor ?? Colors.blue;
  static final Color mainInvertColor = Colors.orange;
  static final Color secondryColor = ConfigService.theme?.secondColor ?? Colors.black38;
  static final Color mainTextColor = Colors.white; //White
  static final Color backgroundColor = ConfigService.theme?.backgroundColor ?? Color.fromRGBO(250, 250, 250, 1);
  static final Color background2Color = Color.fromRGBO(242, 242, 242, 1); //Gray
  static final Color black26Gray = Colors.black26; //Gray 
  static final Color validationErrorColors = Colors.red; //red 

  static getMainThemeIos(){
    
    return CupertinoThemeData(
        barBackgroundColor: Colors.white,
        scaffoldBackgroundColor: Colors.white, // background
        primaryColor: mainColor,
        //primaryContrastingColor: mainColor
      );
    }
    static getMainThemeAndroid(){
    
return ThemeData(
        
        indicatorColor: mainInvertColor,
        selectedRowColor: mainInvertColor,
        secondaryHeaderColor: mainInvertColor,
        textSelectionHandleColor: mainInvertColor,
        textSelectionColor: mainInvertColor,
        bottomAppBarColor: mainInvertColor,
        
        //-------------- Active Styles ----------------------

        iconTheme: IconThemeData(
          color: mainColor,
          size: 30.0
        ),

        textTheme: TextTheme(
          title: TextStyle( fontSize: 20.0),
          subtitle: TextStyle(fontSize: 16.0, color: Colors.black45, 
                      fontWeight: FontWeight.w600),
          body1: TextStyle(fontSize: 15.0, color: Colors.black45, fontWeight: FontWeight.w600)
        ),
        
        disabledColor: Colors.black45,
        primaryColorLight: ThemeService.background2Color,
        primaryColorDark: ThemeService.mainColor,
        dividerColor: Colors.black54,
        scaffoldBackgroundColor: Colors.white, // background
        canvasColor: Colors.white, // background
        hintColor: black26Gray,       
        primaryColor: mainColor,
        highlightColor: Colors.redAccent, // when button pressed
        splashColor: mainColor,// when press affect
        toggleableActiveColor: mainColor,
        errorColor: validationErrorColors,
        dialogBackgroundColor: Colors.white,// for alerts and choises
        cardColor: Colors.white,
        backgroundColor: backgroundColor, 
        unselectedWidgetColor: Colors.black, // radio button
      );
    }


  static TextStyle get labelStyle => TextStyle(
    color: Colors.black26,
    fontSize: 13,
    fontWeight: FontWeight.normal
  );
  static TextStyle get titleStyle => TextStyle(
    color: Colors.black,
    fontSize: 15,
    fontWeight: FontWeight.bold
  );
  static TextStyle get flatButtonTextStyle => TextStyle(
    color: mainColor,
    fontSize: 13,
    fontWeight: FontWeight.normal
  );

}