part of tecfy_basic_package;

class AppButtonPost extends StatefulWidget {
  final String label;
  final Future Function() onPressed;
  AppButtonPost({this.label,this.onPressed});
  @override
  _AppButtonPostState createState() => _AppButtonPostState();
}

class _AppButtonPostState extends State<AppButtonPost> with SingleTickerProviderStateMixin {

  AnimationController _controller;
  Animation<double> _animation;
  Animation<double> _animationRadius;
  bool isBussy = false;
  @override
  initState(){
    _controller = new AnimationController(
      duration: new Duration(milliseconds: 1000),
      vsync: this
    );
    _animation = new Tween(
      begin: 320.0,
      end: 40.0,
    ).animate(new CurvedAnimation(
      parent: _controller,
      curve: new Interval(0.0, 0.250)
    ));
    _animationRadius = new Tween(
      begin: 0.0,
      end: 50.0,
    ).animate(new CurvedAnimation(
      parent: _controller,
      curve: new Interval(0.0, 0.250)
    ));
    _controller.addListener((){
      setState(() {});
    });
    super.initState();
  }

  onPressed()async{
    try{
    isBussy =true;
    _controller.forward();
    await widget.onPressed();
    _controller.reverse();
    isBussy =false;
    }catch(err){}
  }

  showLoading(){
    return isBussy && _animation.value < 100;
  }

  @override
  void dispose() {
    _controller?.stop();
    _controller?.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Hero(tag: "submit_button"+widget.label,child: RaisedButton(
      shape: RoundedRectangleBorder(
        borderRadius: BorderRadius.circular(_animationRadius.value)
      ),
      color: ThemeService.mainColor,
      onPressed: onPressed,
      child:Container(
        height: 60.0,
        width: _animation.value,//double.infinity,
        child: Center(child: showLoading() ? CircularProgressIndicator(valueColor: AlwaysStoppedAnimation<Color>(Colors.white),) : Text(widget.label, style: TextStyle(color: ThemeService.mainTextColor, fontSize: 18.0),)),
      )
    ));
  }
}