part of tecfy_basic_package;

class SearchBox extends StatefulWidget {
  final TextEditingController searchTextController;
  final void Function(String) onChange;
  final void Function(String) onSubmit;
  final String placeholder;
  SearchBox(
      {this.searchTextController,
      this.placeholder,
      this.onChange,
      this.onSubmit});
  @override
  _SearchBoxState createState() => _SearchBoxState();
}

class _SearchBoxState extends State<SearchBox> {
  FocusNode focusNode = FocusNode();
  TextEditingController searchTextController;
  bool hasFocus = false;
  @override
  void initState() {
    searchTextController =
        widget.searchTextController ?? TextEditingController();

    focusNode.addListener(() {
      hasFocus = focusNode.hasFocus;
      setState(() {});
    });
    super.initState();
  }

  @override
  void dispose() {
    focusNode.dispose();
    super.dispose();
  }

  void onChange(val) {
    if (widget.onChange != null) widget.onChange(val.toString().toLowerCase());
  }

  void onSubmit(val) {
    if (widget.onSubmit != null) widget.onSubmit(val);
  }

  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: EdgeInsets.only(left: 10.0, right: 20.0,top: 10.0),
        child: Row(
      children: <Widget>[
        Expanded(
            child: Container(
          margin: EdgeInsets.only(left: 10.0, bottom: 0.0, top: 0.0),
          height: 50.0,
          //width: 250.0,
          decoration: BoxDecoration(
              color: ThemeService.background2Color,
              borderRadius: BorderRadius.all(Radius.circular(5.0)),
              shape: BoxShape.rectangle),
          child: Theme.of(context).platform == TargetPlatform.iOS
              ? CupertinoTextField(
                  textInputAction: TextInputAction.search,
                  keyboardType: TextInputType.text,
                  style: TextStyle(
                      color: ThemeService.mainColor,
                      fontSize: 18.0,
                      fontWeight: FontWeight.bold),
                  //padding: EdgeInsets.only(left:35.0),

                  controller: widget.searchTextController,
                  //autofocus: true,
                  onChanged: onChange,
                  onSubmitted: onSubmit,
                  focusNode: focusNode,
                  placeholder: widget.placeholder,
                  prefix: Padding(
                    padding: const EdgeInsets.only(left: 5.0),
                    child: Icon(
                      Icons.search,
                      color: ThemeService.black26Gray,
                      size: 35.0,
                    ),
                  ),
                  decoration: BoxDecoration(

                      //contentPadding: EdgeInsets.only(top:20.0),

                      //hintStyle: TextStyle(fontWeight: FontWeight.w500,color: ThemeService.Black26Gray,fontSize: 16.0,letterSpacing: 1.0
                      ),
                  //border: OutlineInputBorder(borderRadius: BorderRadius.circular(5.0)),
                  //border: InputBorder.none
                  //),
                )
              : TextField(
                  textInputAction: TextInputAction.search,
                  keyboardType: TextInputType.text,
                  controller: widget.searchTextController,
                  //autofocus: true,
                  onChanged: onChange,
                  onSubmitted: onSubmit,
                  focusNode: focusNode,
                  decoration: InputDecoration(
                      prefixIcon: Padding(
                        padding: const EdgeInsets.only(left: 5.0),
                        child: Icon(
                          Icons.search,
                          color: ThemeService.black26Gray,
                          size: 35.0,
                        ),
                      ),
                      //contentPadding: EdgeInsets.only(top:20.0),
                      hintText: widget.placeholder,
                      hintStyle: TextStyle(
                          fontWeight: FontWeight.w500,
                          color: ThemeService.black26Gray,
                          fontSize: 16.0,
                          letterSpacing: 1.0),
                      //border: OutlineInputBorder(borderRadius: BorderRadius.circular(5.0)),
                      border: InputBorder.none),
                ),
        )),
        isKeyboardIsOpen
            ? FlatButton(
                child: Text(
                  'Cancel',
                  style: TextStyle(
                    color: ThemeService.mainColor,
                  ),
                ),
                onPressed: () {
                  focusNode.unfocus();
                })
            : Container()
      ],
    ));
  }

  bool get isKeyboardIsOpen {
    return hasFocus; //MediaQuery.of(context).viewInsets.bottom != 0;
  }
}
